#include "neuron_model_my_model_curr_impl.h"

#include <debug.h>

static global_neuron_params_pointer_t global_params;

void neuron_model_set_global_neuron_params(
        global_neuron_params_pointer_t params) {
    global_params = params;
}

bool neuron_model_state_update(input_t exc_input, input_t inh_input,
                               input_t external_bias, neuron_pointer_t neuron) {

    if (neuron->t_refract_counter > 0) {
        neuron->t_refract_counter -= 1;
    } else {

        input_t input_this_timestep = exc_input - inh_input
                                      + external_bias + neuron->I_offset;

        neuron->V = neuron->V - ((neuron->V - neuron->V_rest) * neuron->decay)
            + input_this_timestep;

        if (neuron->V >= neuron->V_thresh) {

            neuron->V = neuron->V_reset;
            neuron->t_refract_counter = neuron->t_refract;
            return true;
        }
    }

    return false;
}

state_t neuron_model_get_membrane_voltage(neuron_pointer_t neuron) {

    // TODO: Get the state value representing the membrane voltage
    return neuron->V;
}

void neuron_model_print(restrict neuron_pointer_t neuron) {
    use(neuron);

    // TODO: Printout of neuron definition and state variables
}
